edu.wpi.first.wpilibj.tables

## Interface ITable

- All Known Implementing Classes:
    NetworkTable

  Deprecated.
  Use `NetworkTable`.

      @Deprecated
      public interface ITable

  A table whose values can be read and written to

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `NOTIFY_DELETE` Deprecated.
    `static int` | `NOTIFY_FLAGS` Deprecated.
    `static int` | `NOTIFY_IMMEDIATE` Deprecated. Notifier flag values.
    `static int` | `NOTIFY_LOCAL` Deprecated.
    `static int` | `NOTIFY_NEW` Deprecated.
    `static int` | `NOTIFY_UPDATE` Deprecated.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addSubTableListener(ITableListener listener)` Deprecated. This will immediately notify the listener of all current sub tables
    `void` | `addSubTableListener(ITableListener listener, boolean localNotify)` Deprecated. This will immediately notify the listener of all current sub tables
    `void` | `addTableListener(ITableListener listener)` Deprecated. Add a listener for changes to the table
    `void` | `addTableListener(ITableListener listener, boolean immediateNotify)` Deprecated. Add a listener for changes to the table
    `void` | `addTableListener(java.lang.String key, ITableListener listener, boolean immediateNotify)` Deprecated. Add a listener for changes to a specific key the table
    `void` | `addTableListenerEx(ITableListener listener, int flags)` Deprecated. Add a listener for changes to the table
    `void` | `addTableListenerEx(java.lang.String key, ITableListener listener, int flags)` Deprecated. Add a listener for changes to a specific key the table
    `void` | `clearFlags(java.lang.String key, int flags)` Deprecated. Clears flags on the specified key in this table.
    `void` | `clearPersistent(java.lang.String key)` Deprecated. Stop making a key's value persistent through program restarts.
    `boolean` | `containsKey(java.lang.String key)` Deprecated. Checks the table and tells if it contains the specified key
    `boolean` | `containsSubTable(java.lang.String key)` Deprecated.
    `void` | `delete(java.lang.String key)` Deprecated. Deletes the specified key in this table.
    `boolean` | `getBoolean(java.lang.String key, boolean defaultValue)` Deprecated. Returns the boolean the key maps to.
    `boolean[]` | `getBooleanArray(java.lang.String key, boolean[] defaultValue)` Deprecated. Returns the boolean array the key maps to.
    `java.lang.Boolean[]` | `getBooleanArray(java.lang.String key, java.lang.Boolean[] defaultValue)` Deprecated. Returns the boolean array the key maps to.
    `double` | `getDouble(java.lang.String key, double defaultValue)` Deprecated. Use `getNumber(String, double)` instead.
    `int` | `getFlags(java.lang.String key)` Deprecated. Returns the flags for the specified key.
    `java.util.Set<java.lang.String>` | `getKeys()` Deprecated. Gets all keys in the table (not including sub-tables).
    `java.util.Set<java.lang.String>` | `getKeys(int types)` Deprecated. Gets all keys in the table (not including sub-tables).
    `double` | `getNumber(java.lang.String key, double defaultValue)` Deprecated. Returns the number the key maps to.
    `double[]` | `getNumberArray(java.lang.String key, double[] defaultValue)` Deprecated. Returns the number array the key maps to.
    `java.lang.Double[]` | `getNumberArray(java.lang.String key, java.lang.Double[] defaultValue)` Deprecated. Returns the number array the key maps to.
    `java.lang.String` | `getPath()` Deprecated. Gets the full path of this table.
    `byte[]` | `getRaw(java.lang.String key, byte[] defaultValue)` Deprecated. Returns the raw value (byte array) the key maps to.
    `java.lang.String` | `getString(java.lang.String key, java.lang.String defaultValue)` Deprecated. Returns the string the key maps to.
    `java.lang.String[]` | `getStringArray(java.lang.String key, java.lang.String[] defaultValue)` Deprecated. Returns the string array the key maps to.
    `ITable` | `getSubTable(java.lang.String key)` Deprecated. Returns the table at the specified key.
    `java.util.Set<java.lang.String>` | `getSubTables()` Deprecated. Gets the names of all subtables in the table.
    `java.lang.Object` | `getValue(java.lang.String key, java.lang.Object defaultValue)` Deprecated. Gets the value associated with a key as an object.
    `boolean` | `isPersistent(java.lang.String key)` Deprecated. Returns whether the value is persistent through program restarts.
    `boolean` | `putBoolean(java.lang.String key, boolean value)` Deprecated. Put a boolean in the table
    `boolean` | `putBooleanArray(java.lang.String key, boolean[] value)` Deprecated. Put a boolean array in the table
    `boolean` | `putBooleanArray(java.lang.String key, java.lang.Boolean[] value)` Deprecated. Put a boolean array in the table
    `boolean` | `putDouble(java.lang.String key, double value)` Deprecated. Use `putNumber(String, double)` instead.
    `boolean` | `putNumber(java.lang.String key, double value)` Deprecated. Put a number in the table
    `boolean` | `putNumberArray(java.lang.String key, double[] value)` Deprecated. Put a number array in the table
    `boolean` | `putNumberArray(java.lang.String key, java.lang.Double[] value)` Deprecated. Put a number array in the table
    `boolean` | `putRaw(java.lang.String key, byte[] value)` Deprecated. Put a raw value (byte array) in the table
    `boolean` | `putRaw(java.lang.String key, java.nio.ByteBuffer value, int len)` Deprecated. Put a raw value (bytes from a byte buffer) in the table
    `boolean` | `putString(java.lang.String key, java.lang.String value)` Deprecated. Put a string in the table
    `boolean` | `putStringArray(java.lang.String key, java.lang.String[] value)` Deprecated. Put a string array in the table
    `boolean` | `putValue(java.lang.String key, java.lang.Object value)` Deprecated. Put a value in the table
    `void` | `removeTableListener(ITableListener listener)` Deprecated. Remove a listener from receiving table events
    `boolean` | `setDefaultBoolean(java.lang.String key, boolean defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `boolean` | `setDefaultBooleanArray(java.lang.String key, boolean[] defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `boolean` | `setDefaultBooleanArray(java.lang.String key, java.lang.Boolean[] defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `boolean` | `setDefaultNumber(java.lang.String key, double defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `boolean` | `setDefaultNumberArray(java.lang.String key, double[] defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `boolean` | `setDefaultNumberArray(java.lang.String key, java.lang.Double[] defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `boolean` | `setDefaultRaw(java.lang.String key, byte[] defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `boolean` | `setDefaultString(java.lang.String key, java.lang.String defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `boolean` | `setDefaultStringArray(java.lang.String key, java.lang.String[] defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `void` | `setFlags(java.lang.String key, int flags)` Deprecated. Sets flags on the specified key in this table.
    `void` | `setPersistent(java.lang.String key)` Deprecated. Makes a key's value persistent through program restarts.

- - ### Field Detail

    - #### NOTIFY_IMMEDIATE

          static final int NOTIFY_IMMEDIATE

      Deprecated.
      Notifier flag values.
      See Also:
        Constant Field Values

    - #### NOTIFY_LOCAL

          static final int NOTIFY_LOCAL

      Deprecated.
      See Also:
        Constant Field Values

    - #### NOTIFY_NEW

          static final int NOTIFY_NEW

      Deprecated.
      See Also:
        Constant Field Values

    - #### NOTIFY_DELETE

          static final int NOTIFY_DELETE

      Deprecated.
      See Also:
        Constant Field Values

    - #### NOTIFY_UPDATE

          static final int NOTIFY_UPDATE

      Deprecated.
      See Also:
        Constant Field Values

    - #### NOTIFY_FLAGS

          static final int NOTIFY_FLAGS

      Deprecated.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### containsKey

          boolean containsKey(java.lang.String key)

      Deprecated.
      Checks the table and tells if it contains the specified key
      Parameters:
        `key` - the key to search for
      Returns:
        true if the table as a value assigned to the given key

    - #### containsSubTable

          boolean containsSubTable(java.lang.String key)

      Deprecated.
      Parameters:
        `key` - the key to search for
      Returns:
        true if there is a subtable with the key which contains at least one key/subtable of its own

    - #### getSubTable

          ITable getSubTable(java.lang.String key)

      Deprecated.
      Returns the table at the specified key. If there is no table at the specified key, it will create a new table
      Parameters:
        `key` - the name of the table relative to this one
      Returns:
        a sub table relative to this one

    - #### getKeys

          java.util.Set<java.lang.String> getKeys(int types)

      Deprecated.
      Gets all keys in the table (not including sub-tables).
      Parameters:
        `types` - bitmask of types; 0 is treated as a "don't care".
      Returns:
        keys currently in the table

    - #### getKeys

          java.util.Set<java.lang.String> getKeys()

      Deprecated.
      Gets all keys in the table (not including sub-tables).
      Returns:
        keys currently in the table

    - #### getSubTables

          java.util.Set<java.lang.String> getSubTables()

      Deprecated.
      Gets the names of all subtables in the table.
      Returns:
        subtables currently in the table

    - #### setPersistent

          void setPersistent(java.lang.String key)

      Deprecated.
      Makes a key's value persistent through program restarts. The key cannot be null.
      Parameters:
        `key` - the key name

    - #### clearPersistent

          void clearPersistent(java.lang.String key)

      Deprecated.
      Stop making a key's value persistent through program restarts. The key cannot be null.
      Parameters:
        `key` - the key name

    - #### isPersistent

          boolean isPersistent(java.lang.String key)

      Deprecated.
      Returns whether the value is persistent through program restarts. The key cannot be null.
      Parameters:
        `key` - the key name
      Returns:
        True if the value is persistent.

    - #### setFlags

          void setFlags(java.lang.String key,
                        int flags)

      Deprecated.
      Sets flags on the specified key in this table. The key can not be null.
      Parameters:
        `key` - the key name
        `flags` - the flags to set (bitmask)

    - #### clearFlags

          void clearFlags(java.lang.String key,
                          int flags)

      Deprecated.
      Clears flags on the specified key in this table. The key can not be null.
      Parameters:
        `key` - the key name
        `flags` - the flags to clear (bitmask)

    - #### getFlags

          int getFlags(java.lang.String key)

      Deprecated.
      Returns the flags for the specified key.
      Parameters:
        `key` - the key name
      Returns:
        the flags, or 0 if the key is not defined

    - #### delete

          void delete(java.lang.String key)

      Deprecated.
      Deletes the specified key in this table. The key can not be null.
      Parameters:
        `key` - the key name

    - #### getValue

          java.lang.Object getValue(java.lang.String key,
                                    java.lang.Object defaultValue)

      Deprecated.
      Gets the value associated with a key as an object. NOTE: If the value is a double, it will return a Double object, not a primitive. To get the primitive, use `getDouble(String, double)`.
      Parameters:
        `key` - the key of the value to look up
        `defaultValue` - the default value if the key is null
      Returns:
        the value associated with the given key

    - #### putValue

          boolean putValue(java.lang.String key,
                           java.lang.Object value)
                    throws java.lang.IllegalArgumentException

      Deprecated.
      Put a value in the table
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type
      Throws:
        `java.lang.IllegalArgumentException` - when the value is not supported by the table

    - #### putNumber

          boolean putNumber(java.lang.String key,
                            double value)

      Deprecated.
      Put a number in the table
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### setDefaultNumber

          boolean setDefaultNumber(java.lang.String key,
                                   double defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### getNumber

          double getNumber(java.lang.String key,
                           double defaultValue)

      Deprecated.
      Returns the number the key maps to. If the key does not exist or is of different type, it will return the default value.
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### putString

          boolean putString(java.lang.String key,
                            java.lang.String value)

      Deprecated.
      Put a string in the table
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### setDefaultString

          boolean setDefaultString(java.lang.String key,
                                   java.lang.String defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### getString

          java.lang.String getString(java.lang.String key,
                                     java.lang.String defaultValue)

      Deprecated.
      Returns the string the key maps to. If the key does not exist or is of different type, it will return the default value.
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### putBoolean

          boolean putBoolean(java.lang.String key,
                             boolean value)

      Deprecated.
      Put a boolean in the table
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### setDefaultBoolean

          boolean setDefaultBoolean(java.lang.String key,
                                    boolean defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### getBoolean

          boolean getBoolean(java.lang.String key,
                             boolean defaultValue)

      Deprecated.
      Returns the boolean the key maps to. If the key does not exist or is of different type, it will return the default value.
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### putBooleanArray

          boolean putBooleanArray(java.lang.String key,
                                  boolean[] value)

      Deprecated.
      Put a boolean array in the table
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### setDefaultBooleanArray

          boolean setDefaultBooleanArray(java.lang.String key,
                                         boolean[] defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### putBooleanArray

          boolean putBooleanArray(java.lang.String key,
                                  java.lang.Boolean[] value)

      Deprecated.
      Put a boolean array in the table
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### setDefaultBooleanArray

          boolean setDefaultBooleanArray(java.lang.String key,
                                         java.lang.Boolean[] defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### getBooleanArray

          boolean[] getBooleanArray(java.lang.String key,
                                    boolean[] defaultValue)

      Deprecated.
      Returns the boolean array the key maps to. If the key does not exist or is of different type, it will return the default value.
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### getBooleanArray

          java.lang.Boolean[] getBooleanArray(java.lang.String key,
                                              java.lang.Boolean[] defaultValue)

      Deprecated.
      Returns the boolean array the key maps to. If the key does not exist or is of different type, it will return the default value.
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### putNumberArray

          boolean putNumberArray(java.lang.String key,
                                 double[] value)

      Deprecated.
      Put a number array in the table
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### setDefaultNumberArray

          boolean setDefaultNumberArray(java.lang.String key,
                                        double[] defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### putNumberArray

          boolean putNumberArray(java.lang.String key,
                                 java.lang.Double[] value)

      Deprecated.
      Put a number array in the table
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### setDefaultNumberArray

          boolean setDefaultNumberArray(java.lang.String key,
                                        java.lang.Double[] defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### getNumberArray

          double[] getNumberArray(java.lang.String key,
                                  double[] defaultValue)

      Deprecated.
      Returns the number array the key maps to. If the key does not exist or is of different type, it will return the default value.
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### getNumberArray

          java.lang.Double[] getNumberArray(java.lang.String key,
                                            java.lang.Double[] defaultValue)

      Deprecated.
      Returns the number array the key maps to. If the key does not exist or is of different type, it will return the default value.
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### putStringArray

          boolean putStringArray(java.lang.String key,
                                 java.lang.String[] value)

      Deprecated.
      Put a string array in the table
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### setDefaultStringArray

          boolean setDefaultStringArray(java.lang.String key,
                                        java.lang.String[] defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### getStringArray

          java.lang.String[] getStringArray(java.lang.String key,
                                            java.lang.String[] defaultValue)

      Deprecated.
      Returns the string array the key maps to. If the key does not exist or is of different type, it will return the default value.
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### putRaw

          boolean putRaw(java.lang.String key,
                         byte[] value)

      Deprecated.
      Put a raw value (byte array) in the table
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### setDefaultRaw

          boolean setDefaultRaw(java.lang.String key,
                                byte[] defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### putRaw

          boolean putRaw(java.lang.String key,
                         java.nio.ByteBuffer value,
                         int len)

      Deprecated.
      Put a raw value (bytes from a byte buffer) in the table
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
        `len` - the length of the value
      Returns:
        False if the table key already exists with a different type

    - #### getRaw

          byte[] getRaw(java.lang.String key,
                        byte[] defaultValue)

      Deprecated.
      Returns the raw value (byte array) the key maps to. If the key does not exist or is of different type, it will return the default value.
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### addTableListener

          void addTableListener(ITableListener listener)

      Deprecated.
      Add a listener for changes to the table
      Parameters:
        `listener` - the listener to add

    - #### addTableListener

          void addTableListener(ITableListener listener,
                                boolean immediateNotify)

      Deprecated.
      Add a listener for changes to the table
      Parameters:
        `listener` - the listener to add
        `immediateNotify` - if true then this listener will be notified of all current entries (marked as new)

    - #### addTableListenerEx

          void addTableListenerEx(ITableListener listener,
                                  int flags)

      Deprecated.
      Add a listener for changes to the table
      Parameters:
        `listener` - the listener to add
        `flags` - bitmask specifying desired notifications

    - #### addTableListener

          void addTableListener(java.lang.String key,
                                ITableListener listener,
                                boolean immediateNotify)

      Deprecated.
      Add a listener for changes to a specific key the table
      Parameters:
        `key` - the key to listen for
        `listener` - the listener to add
        `immediateNotify` - if true then this listener will be notified of all current entries (marked as new)

    - #### addTableListenerEx

          void addTableListenerEx(java.lang.String key,
                                  ITableListener listener,
                                  int flags)

      Deprecated.
      Add a listener for changes to a specific key the table
      Parameters:
        `key` - the key to listen for
        `listener` - the listener to add
        `flags` - bitmask specifying desired notifications

    - #### addSubTableListener

          void addSubTableListener(ITableListener listener)

      Deprecated.
      This will immediately notify the listener of all current sub tables
      Parameters:
        `listener` - the listener to notify

    - #### addSubTableListener

          void addSubTableListener(ITableListener listener,
                                   boolean localNotify)

      Deprecated.
      This will immediately notify the listener of all current sub tables
      Parameters:
        `listener` - the listener to notify
        `localNotify` - if true then this listener will be notified of all local changes in addition to all remote changes

    - #### removeTableListener

          void removeTableListener(ITableListener listener)

      Deprecated.
      Remove a listener from receiving table events
      Parameters:
        `listener` - the listener to be removed

    - #### putDouble

          @Deprecated
          boolean putDouble(java.lang.String key,
                                        double value)

      Deprecated. Use `putNumber(String, double)` instead.
      Maps the specified key to the specified value in this table. The key can not be null. The value can be retrieved by calling the get method with a key that is equal to the original key.
      Parameters:
        `key` - the key
        `value` - the value
      Returns:
        False if the table key already exists with a different type
      Throws:
        `java.lang.IllegalArgumentException` - if key is null

    - #### getDouble

          @Deprecated
          double getDouble(java.lang.String key,
                                       double defaultValue)

      Deprecated. Use `getNumber(String, double)` instead.
      Returns the value at the specified key.
      Parameters:
        `key` - the key
        `defaultValue` - the value returned if the key is undefined
      Returns:
        the value
      Throws:
        `java.lang.IllegalArgumentException` - if the value mapped to by the key is not a double
        `java.lang.IllegalArgumentException` - if the key is null

    - #### getPath

          java.lang.String getPath()

      Deprecated.
      Gets the full path of this table. Does not include the trailing "/".
      Returns:
        The path to this table (e.g. "", "/foo").